var videoPlayer;
var moviePlayer;
//视频ID
var videoName;

//zt_list表id
var entityId;

//视频参数信息
var duration = 0;
//视频总时长
var nowPlayTimes = 0;
//当前播放
var eventType = '';
//字符串类型；播放事件类型，仅当 name 为 play 时有值；取值范围如下：//start（开始播放）//playing（正在播放）//pause（播放暂停）//stop（播放停止）//complete（播放完成）
var videoURL = '';
//视频播放地址

//视频控制栏是否显示
var videoControlTypes = true;

var wo_robot_id;
var news_id;
var entitygrade;

var htmlAppendFlag = false;
var pageNo = 1;
var hasNext = true;
var nextPage = 1;
apiready = function() {
	api.parseTapmode();
	videoPlayer = api.require('videoPlayer');	
	moviePlayer = api.require('moviePlayer');
	wo_robot_id = api.pageParam.wo_robot_id;	
	news_id = api.pageParam.news_id;
	entitygrade = '84500042-a0a3-498a-a523-e8a9d010cc2c';

	//安卓返回键
	keyBack();

	//数据加载
	getVideoList(wo_robot_id,1);
	setStyle();
};

var moveId ='';
var movelength =0;
var movesize =0;
function load(){
	var myBody = document.getElementById(moveId);
	var startX, startY, moveEndX, moveEndY, X, Y;
	myBody.addEventListener('touchstart', function(e) {
		// e.preventDefault();
		startX = e.touches[0].pageX;
	  	startY = e.touches[0].pageY; 
	}, false);
	myBody.addEventListener('touchmove', function(e) {
	  	moveEndX = e.changedTouches[0].pageX;
	  	moveEndY = e.changedTouches[0].pageY;
	  	X = moveEndX - startX; Y = moveEndY - startY;
	});
	myBody.addEventListener('touchend', function(e) {
	 	if( Math.abs(Y) > Math.abs(X) && Y < 0 ) {
			//console.log('向下')
			if(myBody.scrollTop > (movelength*movesize)-$api.offset($api.byId(moveId)).h){
				//console.log(myBody.scrollTop+"--"+length*size+"--"+$api.offset($api.byId(id)).h);
				//console.log('到底部')
				movelength = movelength+1000;
				if (hasNext) {
					htmlAppendFlag = true;
					getVideoList(wo_robot_id,nextPage);
				}					
			}
		}
	});
}



function getVideoList(robot_id,pageNO) {
	var pageSize = 1000;
	api.ajax({
		url : robotURL + 'newsList/' + pageNO,
		method : 'post',
		cache : false,
		timeout : 30,
		dataTpye : 'json',
		data : {
			values : {
				pageSize : pageSize,
				wo_robot_id : robot_id,
				type : 'video'
			}
		},
		returnAll : false,
	}, function(ret, err) {
		if (ret && ret.result.length > 0) {
			hasNext = ret.hasNext;
			nextPage = ret.nextPage;
			var html_1 = '<div class="scroll_list" id="scroll_list"><ul>';
			var html ='';
			var html_2='';
			var k;
			for (var i = 0; i <ret.result.length; i++) {				
				if(ret.result[i].news_id==news_id){//判断是否选中
					html_2 += '<li onclick="openVideo(\''+ret.result[i].news_id+'\',\''+ret.result[i].play_path+'\',\''+ret.result[i].title+'\',this,\''+ret.result[i].is_free+'\');" class="active" style="height:' + api.winHeight * 0.81 * 0.88 * 0.247 + 'px;">';					
					html_2 += '<div class="videoImg">';
					html_2 += '<img src="'+ret.result[i].picture+'"/>';
					html_2 += '<img src="../../image/pages/index/bmw/second/video_zz.png"/>';
					html_2 += '</div>';
					html_2 += '<div class="video_datail" style="line-height:' + api.winHeight * 0.81 * 0.88 * 0.247 * 0.2 + 'px;">';
					html_2 += '<p>'+ret.result[i].title+'</p>';
					html_2 += '<span><img src="../../image/pages/index/bmw/second/play_icon.png"/>'+ret.result[i].pv_total+'</span>';
					html_2 += '</div>';
					html_2 += '</li>';					
					k=i;					
				}else{
					html += '<li onclick="openVideo(\''+ret.result[i].news_id+'\',\''+ret.result[i].play_path+'\',\''+ret.result[i].title+'\',this,\''+ret.result[i].is_free+'\');" style="height:' + api.winHeight * 0.81 * 0.88 * 0.247 + 'px;">';					
					html += '<div class="videoImg">';
					html += '<img src="'+ret.result[i].picture+'"/>';
					html += '<img src="../../image/pages/index/bmw/second/video_zz.png"/>';
					html += '</div>';
					html += '<div class="video_datail" style="line-height:' + api.winHeight * 0.81 * 0.88 * 0.247 * 0.2 + 'px;">';
					html += '<p>'+ret.result[i].title+'</p>';
					html += '<span><img src="../../image/pages/index/bmw/second/play_icon.png"/>'+ret.result[i].pv_total+'</span>';
					html += '</div>';
					html += '</li>';
				}		

			}
			html = html_2+html;
			moveId = 'scroll_list';
			movelength = pageSize;
			movesize = api.winHeight * 0.81 * 0.88 * 0.247;
			if (htmlAppendFlag) {
				$api.append($api.dom($api.byId('video_list'), 'ul'), html);
				//console.log('--:'+html)
			} else {
				html_1 += html+'</ul></div>';
				$api.html($api.byId('video_list'), html_1);
				load();
			}	
			if(pageNO==1){
				openVideo(ret.result[k].news_id,ret.result[k].play_path,ret.result[k].title,0,ret.result[k].is_free);	
			}
			
			
		}
	}); 

		
		
		

}

//查询视频信息


//安卓返回键
function keyBack() {
	api.addEventListener({
		name : 'keyback'
	}, function(ret, err) {
		backWin();
	});
}

//设置视频播放地址
function setPath(videoPath) {
	videoPlayer.setPath({
		path : videoPath,
		coverImg : 'widget://image/loading.jpg',
	});
}

//打开视频播放器
var key =true;
var playvideoURL;
function openVideo(new_id,videoURL,title,obj,is_free) {
	updateNewsPV(new_id);
	playVideoURL = videoURL;
	var pName = $api.getStorage('pName');
	if((pName !=null && pName !='' && pName !=undefined && pName !='undefined') || is_free == 0 || is_free == 1){
		news_id=new_id;
		var len = $api.domAll($api.byId('scroll_list'), 'li');
		for (var i = 0; i < len.length; i++) {
			$api.removeCls(len[i], 'active');
		}
		
		if(obj==0){
			$api.addCls(len[0], 'active');
		}else{
			$api.addCls(obj, 'active');
		}
	
	
		$('#videoTitle').text(title);	
		if(key){
			key=false;
			fnvideoPlayerOpen(videoURL);
			
		}else{
			videoPlayer.setPath({
			    path: videoURL,
			    coverImg: ''
			});	
		}	
	}else{
		setTimeout(function() {
			if(api.systemType=='ios'){
				api.openWin({
				    name: 'ios_order',
				    url: 'ios_order.html',
				    pageParam : {
						wo_robot_id : wo_robot_id,
						come_type:4,
						entitygrade:entitygrade,
						news_id:new_id
					}
			    });	
			}else{
				if(channelType != '3jidi_p_huawei_ct'){
					api.openWin({
					    name: 'android_order',
					    url: 'android_order.html',
					    pageParam : {
							wo_robot_id : wo_robot_id,
							come_type:4,
							entitygrade:entitygrade,
							news_id:new_id
						}
				    });	
				
				}else{
					api.openWin({
					    name: 'android_ct_order',
					    url: 'android_ct_order.html',
					    pageParam : {
//							wo_robot_id : wo_robot_id,
							come_type:4,
							entitygrade:entitygrade
//							news_id:new_id
						}
				    });					
				}
			}			
		}, 500)	


	}

}

//调用普通视频播放器（可编辑播放器）
function fnvideoPlayerOpen(videoURL) {
	videoPlayer.open({
		rect : {
			x : api.winWidth*0.361+api.winWidth*0.615*0.01,
			y : api.winHeight*0.139+api.winHeight*0.81*0.111,
			w : api.winWidth * 0.615*0.98, 
			h : api.winHeight * 0.81*0.884
		},
		bg : '#fff', //视频背景颜色，支持#、rgb、rgba (在切换视屏为了防止闪屏,请根据自己的视频调节颜色)
		path : videoURL, //视频播放地址
		autoPlay : true, //打开时是否自动播放
		scalingMode : 'scaleToFill', //该参数仅支持ios
		coverImg : "widget://image/videoPlayer/video_load.png" //播放器打开尚未播放时的封面图
	}, function(ret, err) {
		if (ret.status) {
			//alert(JSON.stringify(ret));
			//获取视频总时长
			if (ret.duration != '' && ret.duration != null && ret.duration != 'undefined') {
				duration = JSON.stringify(ret.duration).replace(/\"/g, "");
			}
			//默认5s之后自动隐藏控制栏
			showControl();

			//打开自定义播放器样式
			openVideoController();
			//openVideoTool();

			//监听播放器事件
			videoPlayerAddEventListener();
		} else {
			//alert(JSON.stringify(err));
			api.toast({
				msg : err.msg,
				duration : 2000,
				location : 'middle'
			});
		}
	});
}

//打开自定义播放器样式
function openVideoController() {
	api.openFrame({
		name : 'video_foot_01',
		url : '../videoPlayer/video_foot_01.html',
		bounces : false,
		rect : {
			x : api.winWidth*0.361+api.winWidth*0.615*0.01,
			y : api.winHeight*0.139+api.winHeight*0.81*0.995 - 50,
			w : api.winWidth * 0.615*0.98,
			h : 50
		},
		reload : true,
		slidBackEnabled : false,
		pageParam : {
			duration : duration,
			winType:'bmw_three_video_window'
		}
	});
}

//视频播放
function videoPlay() {
	videoPlayer.start();
}

//视频暂停
function videoPause() {
	videoPlayer.pause();
}

//视频全屏
function fullScreen() {
	var winWidth = api.winWidth;
	var winHeight = api.winHeight;
	var w;
	var h;
	if (winWidth > winHeight) {
		w = winWidth;
		h = winHeight;
	} else {
		w = winHeight;
		h = winWidth;
	}
	videoPlayer.setRect({
		rect : {
			x : 0, //（可选项）数字类型；模块左上角的 x 坐标（相对于所属的 Window 或 Frame）；默认：0
			y : 0, //（可选项）数字类型；模块左上角的 y 坐标（相对于所属的 Window 或 Frame）；默认：0
			w : w, //（可选项）数字类型；模块的宽度；默认：所属的 Window 或 Frame 的宽度
			h : h //（可选项）数字类型；模块的高度；默认：w的3/4
		},
		fullscreen : true
	});
	api.setFrameAttr({
		name : 'video_foot_01',
		rect : {
			x : 0,
			y : h - 50,
			w : w,
			h : 50
		},
	});
}

//视频非全屏
function unfullScreen() {
	var winWidth = api.winWidth;
	var winHeight = api.winHeight;
	var w;
	var h;
	if (winWidth > winHeight) {
		w = winWidth;
		h = winHeight;
	} else {
		w = winHeight;
		h = winWidth;
	}
	videoPlayer.setRect({
		rect : {
			x : w*0.361+w*0.615*0.01,
			y : h*0.139+h*0.81*0.111,
			w : w*0.615*0.98, 
			h : h*0.81*0.884
		},
		fullscreen : true
	});
	api.setFrameAttr({
		name : 'video_foot_01',
		rect : {
			x : w*0.361+w*0.615*0.01,
			y : h*0.139+h*0.81*0.995 - 50,
			w : w*0.615*0.98,
			h : 50
		},
	});
}

//设置视频播放时间
function seekToPlay(times) {
	if (eventType && eventType.replace(/\"/g, "") == 'complete') {
		//videoPlayer.seekTo({seconds: 0});
		videoPlayer.setPath({
			path : videoURL,
			coverImg : "widget://image/videoPlayer/video_load.png" //播放器打开尚未播放时的封面图
		});
	}
	videoPlayer.seekTo({
		seconds : times
	});
	videoPlayerAddEventListener();
}


var set;
function hideControl() {
	videoControlTypes = false;
	api.sendEvent({
		name : 'videoControl',
		extra : {
			videoControlType : 0
		}
	});
}

function showControl() {
	videoControlTypes = true;
	api.sendEvent({
		name : 'videoControl',
		extra : {
			videoControlType : 1
		}
	});
	//
	window.clearTimeout(set);
	set = window.setTimeout(function() {
		hideControl();
	}, 5000);
}

//设置样式
function setStyle() {
	$api.css($api.byId('video_msg'), 'line-height:' + api.winHeight * 0.81 * 0.11 + 'px;');
}


//关闭当前页面
function closeThis() {
	$api.attr($api.byId('return'), 'src', '../../image/pages/index/bmw/second/return_focus.png');

	backWin();
}

function seekToVideoPlayer(times) {
	videoPlayer.seekTo({
		seconds : times
	});
}




//视频播放器监听事件
function videoPlayerAddEventListener() {
	videoPlayer.addEventListener({
		name : 'leftUp'
	}, function(ret, err) {
		if (ret) {
			//alert(JSON.stringify(ret));
		} else {
			//alert(JSON.stringify(err));
		}
	});

	videoPlayer.addEventListener({
		name : 'leftDown'
	}, function(ret, err) {
		if (ret) {
			//alert(JSON.stringify(ret));
		} else {
			//alert(JSON.stringify(err));
		}
	});

	videoPlayer.addEventListener({
		name : 'rightUp'
	}, function(ret, err) {
		if (ret) {
			//alert(JSON.stringify(ret));
		} else {
			//alert(JSON.stringify(err));
		}
	});

	videoPlayer.addEventListener({
		name : 'rightDown'
	}, function(ret, err) {
		if (ret) {
			// alert(JSON.stringify(ret));
		} else {
			// alert(JSON.stringify(err));
		}
	});

	videoPlayer.addEventListener({
		name : 'swipeLeft'
	}, function(ret, err) {
		if (ret) {
			// alert(JSON.stringify(ret));
		} else {
			//alert(JSON.stringify(err));
		}
	});

	videoPlayer.addEventListener({
		name : 'swipeRight'
	}, function(ret, err) {
		if (ret) {
			// alert(JSON.stringify(ret));
		} else {
			//alert(JSON.stringify(err));
		}
	});

	//屏幕点击事件
	videoPlayer.addEventListener({
		name : 'click'
	}, function(ret, err) {
		if (ret) {
			//点击显示隐藏
			window.clearTimeout(set);
			if (videoControlTypes) {
				hideControl();
			} else {
				showControl();
			}

		} else {
			//alert(JSON.stringify(err));
		}
	});

	videoPlayer.addEventListener({
		name : 'play'
	}, function(ret, err) {
		if (ret) {
			nowPlayTimes = JSON.stringify(ret.current);
			eventType = JSON.stringify(ret.eventType);
			if ('complete' == eventType.replace(/\"/g, "")) {
				api.removeEventListener({
					name : 'playType'
				});
				api.sendEvent({
					name : 'playType',
					extra : {
						eventType : eventType
					}
				});
			} else if ('playing' == eventType.replace(/\"/g, "")) {
				api.sendEvent({
					name : 'playType',
					extra : {
						nowPlayTimes : nowPlayTimes,
						eventType : eventType
					}
				});
			}

		} else {
			//alert(JSON.stringify(err));
		}
	});

}


//设置播放器属性
function videoControl(type) {
	switch (type) {
		case 'play':
			videoPlayer.start();
			break;
		case 'pause':
			videoPlayerAddEventListener();
			videoPlayer.pause();
			break;
		case 'fullScreen':
			videoPlayer.fullScreen();
			videoPlayer.setRect({
				rect : {
					x : 0, //（可选项）数字类型；模块左上角的 x 坐标（相对于所属的 Window 或 Frame）；默认：0
					y : 0, //（可选项）数字类型；模块左上角的 y 坐标（相对于所属的 Window 或 Frame）；默认：0
					w : api.winWidth, //（可选项）数字类型；模块的宽度；默认：所属的 Window 或 Frame 的宽度
					h : api.winHeight //（可选项）数字类型；模块的高度；默认：w的3/4
				},
				fullscreen : true
			});
			api.setFrameAttr({
				name : 'play_control',
				rect : {
					x : 0,
					y : api.winHeight - api.winHeight * 0.3287,
					w : api.winWidth,
					h : api.winHeight * 0.3287
				}
			});

			break;
		case 'cancelFullScreen':
			videoPlayer.setRect({
				rect : {
					x : api.winWidth * 0.361 + api.winWidth * 0.615 * 0.01, //（可选项）数字类型；模块左上角的 x 坐标（相对于所属的 Window 或 Frame）；默认：0
					y : api.winHeight * 0.139 + api.winHeight * 0.81 * 0.111, //（可选项）数字类型；模块左上角的 y 坐标（相对于所属的 Window 或 Frame）；默认：0
					w : api.winWidth * 0.615 * 0.98, //（可选项）数字类型；模块的宽度；默认：所属的 Window 或 Frame 的宽度
					h : api.winHeight * 0.81 * 0.743//（可选项）数字类型；模块的高度；默认：w的3/4
				},
			});
			api.setFrameAttr({
				name : 'play_control',
				rect : {
					x : api.winWidth * 0.3611,
					y : api.winHeight * 0.6195,
					w : api.winWidth * 0.615,
					h : api.winHeight * 0.3287
				},
			});
			
			break;
	}
}


//分享弹出
function popups() {	
	api.openFrame({
	    name: 'video_fx',
	    url: 'share/video_fx.html',
	    rect: {
		    x:0,
		    y:0,
		    w:api.winWidth,
		    h:api.winHeight
	    },		
		pageParam : { 
			news_id : news_id
		}
	    
    });
	
	//$api.css($api.byId('wx_fx'), 'display:block;');
}

//添加用户播放日志表
function addUserPlayLog(){
	var u_code = $api.getStorage('uCode');
    api.ajax({
		url : logURL + 'playLogs',
		method : 'post',
		cache : false,
		timeout : 30,
		dataTpye : 'json',
		data : {
			values : {
				u_code:u_code,
				list_id:news_id,
				zhztinfoid:wo_robot_id,
				list_type:'bwm_video'										
			}
		},
		returnAll : false,
	}, function(ret, err) {
		if(ret){
			if(ret.code=='200'){
				console.log(ret.msg);
			}
		}
	});    
}
